searchNodes=[{"doc":"Usage In the most typical use of Poolex, you only need to start pool of workers as a child of your application. children = [ Poolex . child_spec ( pool_id : :worker_pool , worker_module : SomeWorker , workers_count : 5 ) ] Supervisor . start_link ( children , strategy : :one_for_one ) Then you can execute any code on the workers with run/3 : Poolex . run ( :worker_pool , &amp; ( is_pid? ( &amp;1 ) ) , timeout : 1_000 ) { :ok , true } Fore more information see Getting Started","ref":"Poolex.html","title":"Poolex","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. Options Option Description Example Default value pool_id Identifier by which you will access the pool :my_pool option is required worker_module Name of module that implements our worker MyApp.Worker option is required workers_count How many workers should be running in the pool 5 option is required max_overflow How many workers can be created over the limit 2 0 worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] worker_start_fun Name of the function that starts the worker :run :start_link Examples children = [ Poolex . child_spec ( pool_id : :worker_pool_1 , worker_module : SomeWorker , workers_count : 5 ) , # or in another way { Poolex , [ pool_id : :worker_pool_2 , worker_module : SomeOtherWorker , workers_count : 5 ] } ] Supervisor . start_link ( children , strategy : :one_for_one )","ref":"Poolex.html#child_spec/1","title":"Poolex.child_spec/1","type":"function"},{"doc":"Returns detailed information about started pool. Primarily needed to help with debugging. Avoid using this function in production. Fields * ` busy_workers_count ` - how many workers are busy right now . * ` busy_workers_pids ` - list of busy workers . * ` idle_workers_count ` - how many workers are ready to work . * ` idle_workers_pids ` - list of idle workers . * ` max_overflow ` - how many workers can be created over the limit . * ` overflow ` - current count of workers launched over limit . * ` waiting_caller_pids ` - list of callers processes . * ` worker_args ` - what parameters are used to start the worker . * ` worker_module ` - name of a module that describes a worker . * ` worker_start_fun ` - what function is used to start the worker . Examples iex&gt; Poolex . start ( pool_id : :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; debug_info = % Poolex.DebugInfo { } = Poolex . get_debug_info ( :my_pool ) iex&gt; debug_info . busy_workers_count 0 iex&gt; debug_info . idle_workers_count 5","ref":"Poolex.html#get_debug_info/1","title":"Poolex.get_debug_info/1","type":"function"},{"doc":"Returns current state of started pool. Primarily needed to help with debugging. Avoid using this function in production. Examples iex&gt; Poolex . start ( pool_id : :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; state = % Poolex.State { } = Poolex . get_state ( :my_pool ) iex&gt; state . worker_module Agent iex&gt; is_pid ( state . supervisor ) true","ref":"Poolex.html#get_state/1","title":"Poolex.get_state/1","type":"function"},{"doc":"Same as run!/3 but handles runtime_errors. Returns: {:runtime_error, reason} on errors. :all_workers_are_busy if no free worker was found before the timeout. See run!/3 for more information. Examples iex&gt; Poolex . start_link ( pool_id : :some_pool , worker_module : Agent , worker_args : [ fn -&gt; 5 end ] , workers_count : 1 ) iex&gt; Poolex . run ( :some_pool , fn _pid -&gt; raise RuntimeError end ) { :runtime_error , % RuntimeError { message : &quot;runtime error&quot; } } iex&gt; Poolex . run ( :some_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) { :ok , 5 }","ref":"Poolex.html#run/3","title":"Poolex.run/3","type":"function"},{"doc":"The main function for working with the pool. When executed, an attempt is made to obtain a worker with the specified timeout (5 seconds by default). In case of successful execution of the passed function, the result will be returned, otherwise an error will be raised. Examples iex&gt; Poolex . start_link ( pool_id : :some_pool , worker_module : Agent , worker_args : [ fn -&gt; 5 end ] , workers_count : 1 ) iex&gt; Poolex . run! ( :some_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) 5","ref":"Poolex.html#run!/3","title":"Poolex.run!/3","type":"function"},{"doc":"Starts a Poolex process without links (outside of a supervision tree). See start_link/1 for more information. Examples iex&gt; Poolex . start ( pool_id : :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; % Poolex.State { worker_module : worker_module } = Poolex . get_state ( :my_pool ) iex&gt; worker_module Agent","ref":"Poolex.html#start/1","title":"Poolex.start/1","type":"function"},{"doc":"Starts a Poolex process linked to the current process. This is often used to start the Poolex as part of a supervision tree. After the process is started, you can access it using the previously specified pool_id . Options Option Description Example Default value pool_id Identifier by which you will access the pool :my_pool option is required worker_module Name of module that implements our worker MyApp.Worker option is required workers_count How many workers should be running in the pool 5 option is required max_overflow How many workers can be created over the limit 2 0 worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] worker_start_fun Name of the function that starts the worker :run :start_link Examples iex&gt; Poolex . start_link ( pool_id : :other_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; % Poolex.State { worker_module : worker_module } = Poolex . get_state ( :other_pool ) iex&gt; worker_module Agent","ref":"Poolex.html#start_link/1","title":"Poolex.start_link/1","type":"function"},{"doc":"","ref":"Poolex.html#t:pool_id/0","title":"Poolex.pool_id/0","type":"type"},{"doc":"","ref":"Poolex.html#t:poolex_option/0","title":"Poolex.poolex_option/0","type":"type"},{"doc":"","ref":"Poolex.html#t:run_option/0","title":"Poolex.run_option/0","type":"type"},{"doc":"Behaviour for callers collection implementations. caller is a process that uses the Poolex.run/3 function and waits for the execution result. Note that the caller's typespec matches GenServer.from()","ref":"Poolex.Callers.Behaviour.html","title":"Poolex.Callers.Behaviour","type":"behaviour"},{"doc":"Adds caller to state and returns new state.","ref":"Poolex.Callers.Behaviour.html#c:add/2","title":"Poolex.Callers.Behaviour.add/2","type":"callback"},{"doc":"Returns true if the state is empty, false otherwise.","ref":"Poolex.Callers.Behaviour.html#c:empty?/1","title":"Poolex.Callers.Behaviour.empty?/1","type":"callback"},{"doc":"Returns state (any data structure) which will be passed as the first argument to all other functions.","ref":"Poolex.Callers.Behaviour.html#c:init/0","title":"Poolex.Callers.Behaviour.init/0","type":"callback"},{"doc":"Removes one of callers from state and returns it as {caller, state} . Returns :empty if state is empty.","ref":"Poolex.Callers.Behaviour.html#c:pop/1","title":"Poolex.Callers.Behaviour.pop/1","type":"callback"},{"doc":"Removes given caller by caller's pid from state and returns new state.","ref":"Poolex.Callers.Behaviour.html#c:remove_by_pid/2","title":"Poolex.Callers.Behaviour.remove_by_pid/2","type":"callback"},{"doc":"Returns list of callers.","ref":"Poolex.Callers.Behaviour.html#c:to_list/1","title":"Poolex.Callers.Behaviour.to_list/1","type":"callback"},{"doc":"","ref":"Poolex.Callers.Behaviour.html#t:state/0","title":"Poolex.Callers.Behaviour.state/0","type":"type"},{"doc":"Information with the current state of the pool. Can be used for debugging.","ref":"Poolex.DebugInfo.html","title":"Poolex.DebugInfo","type":"module"},{"doc":"","ref":"Poolex.DebugInfo.html#t:t/0","title":"Poolex.DebugInfo.t/0","type":"type"},{"doc":"Behaviour for worker collection implementations.","ref":"Poolex.Workers.Behaviour.html","title":"Poolex.Workers.Behaviour","type":"behaviour"},{"doc":"Adds worker's pid to state and returns new state.","ref":"Poolex.Workers.Behaviour.html#c:add/2","title":"Poolex.Workers.Behaviour.add/2","type":"callback"},{"doc":"Returns the number of workers in the state.","ref":"Poolex.Workers.Behaviour.html#c:count/1","title":"Poolex.Workers.Behaviour.count/1","type":"callback"},{"doc":"Returns true if the state is empty, false otherwise.","ref":"Poolex.Workers.Behaviour.html#c:empty?/1","title":"Poolex.Workers.Behaviour.empty?/1","type":"callback"},{"doc":"Returns state (any data structure) which will be passed as the first argument to all other functions.","ref":"Poolex.Workers.Behaviour.html#c:init/0","title":"Poolex.Workers.Behaviour.init/0","type":"callback"},{"doc":"Same as init/0 but returns state initialized with passed list of workers.","ref":"Poolex.Workers.Behaviour.html#c:init/1","title":"Poolex.Workers.Behaviour.init/1","type":"callback"},{"doc":"Returns true if given worker contained in the state , false otherwise.","ref":"Poolex.Workers.Behaviour.html#c:member?/2","title":"Poolex.Workers.Behaviour.member?/2","type":"callback"},{"doc":"Removes one of workers from state and returns it as {caller, state} . Returns :empty if state is empty.","ref":"Poolex.Workers.Behaviour.html#c:pop/1","title":"Poolex.Workers.Behaviour.pop/1","type":"callback"},{"doc":"Removes given worker from state and returns new state.","ref":"Poolex.Workers.Behaviour.html#c:remove/2","title":"Poolex.Workers.Behaviour.remove/2","type":"callback"},{"doc":"Returns list of workers pids.","ref":"Poolex.Workers.Behaviour.html#c:to_list/1","title":"Poolex.Workers.Behaviour.to_list/1","type":"callback"},{"doc":"","ref":"Poolex.Workers.Behaviour.html#t:state/0","title":"Poolex.Workers.Behaviour.state/0","type":"type"},{"doc":"Poolex is written in Elixir . For branching management, this project uses git-flow . The main branch is reserved for releases: the development process occurs on develop and feature branches. Please never commit to main . You can use asdf to set up required Elixir and OTP. Current versions are listed in the .tool-versions file.","ref":"contributing.html","title":"Contributing to Poolex","type":"extras"},{"doc":"Local repository Fork the repository. Clone your fork to a local repository: git clone https://github.com/your-login/poolex.git cd poolex Checkout develop : git checkout develop Development environment (using asdf) Install asdf by Getting Started guideline Add plugins for elixir and OTP asdf plugin-add elixir https://github.com/asdf-vm/asdf-elixir.git asdf plugin add erlang https://github.com/asdf-vm/asdf-erlang.git Install tools: cd poolex asdf install Development environment (without asdf) Please see installation instructions . Git-flow If you want to use git-flow CLI, please check installation instructions . Building the project Fetch the project dependecies: cd poolex mix deps.get Run the static analyzers: mix check","ref":"contributing.html#setup","title":"Contributing to Poolex - Setup","type":"extras"},{"doc":"To make a change, please use this workflow: Checkout develop and apply the last upstream changes (use rebase, not merge!): git checkout develop git fetch --all --prune git rebase upstream/develop For a tiny patch, create a new branch with an explicit name: git checkout -b &lt;my_branch&gt; Alternatively, if you are working on a feature which would need more work, you can create a feature branch with git-flow : git flow feature start &lt;my_feature&gt; Note: always open an issue and ask before starting a big feature, to avoid it not beeing merged and your time lost. When your feature is ready, feel free to use interactive rebase so your history looks clean and is easy to follow. Then, apply the last upstream changes on develop to prepare integration: git checkout develop git fetch --all --prune git rebase upstream/develop If there were commits on develop since the beginning of your feature branch, integrate them by rebasing if your branch has few commits, or merging if you had a long-lived branch: git checkout &lt;my_feature_branch&gt; git rebase develop Note: the only case you should merge is when you are working on a big feature. If it is the case, we should have discussed this before as stated above. Run the tests and static analyzers to ensure there is no regression and all works as expected: mix check If it’s all good, open a pull request to merge your branch into the develop branch on the main repository.","ref":"contributing.html#workflow","title":"Contributing to Poolex - Workflow","type":"extras"},{"doc":"Please format your code with mix format or your editor and follow this style guide . All contributed code must be documented and functions must have typespecs. In general, take your inspiration from the existing code.","ref":"contributing.html#coding-style","title":"Contributing to Poolex - Coding style","type":"extras"},{"doc":"Getting Started Example of use Custom workers/callers implementations","ref":"guides.html","title":"Poolex guides","type":"extras"},{"doc":"Poolex operates with two concepts: callers and workers . In both cases, we are talking about processes.","ref":"custom-implementations.html","title":"Custom Implementations","type":"extras"},{"doc":"Callers are processes that have made a request to get a worker (used run/3 or run!/3 ). Each pool keeps information about callers in order to distribute workers to them when they are free. :warning: Caller's typespec is GenServer.from() not a pid() :warning: The implementation of the caller storage structure should be conceptually similar to a queue, since by default we want to give workers in the order they are requested. But this logic can be easily changed by writing your own implementation. Behaviour of callers collection described here . Default implementation based on erlang :queue you can see here . Behaviour callbacks Callback Description init/0 Returns state (any data structure) which will be passed as the first argument to all other functions. add/2 Adds caller to state and returns new state. empty?/1 Returns true if the state is empty, false otherwise. pop/1 Removes one of callers from state and returns it as {caller, state} . Returns :empty if state is empty. remove_by_pid/2 Removes given caller by caller's pid from state and returns new state. to_list/1 Returns list of callers.","ref":"custom-implementations.html#callers","title":"Custom Implementations - Callers","type":"extras"},{"doc":"Workers are processes launched in a pool. Poolex works with two collections of workers: IdleWorkers -- Free processes that can be given to callers upon request. BusyWorkers -- Processes that are currently processing the caller's request. For both cases, the default implementation is based on lists. But it is possible to set different implementations for them. Behaviour of workers collection described here . Default implementation for idle and busy workers is here . Behaviour callbacks Callback Description init/0 Returns state (any data structure) which will be passed as the first argument to all other functions. init/1 Same as init/0 but returns state initialized with passed list of workers. add/2 Adds worker's pid to state and returns new state. member?/2 Returns true if given worker contained in the state , false otherwise. remove/2 Removes given worker from state and returns new state. count/1 Returns the number of workers in the state. to_list/1 Returns list of workers pids. empty?/1 Returns true if the state is empty, false otherwise. pop/1 Removes one of workers from state and returns it as {caller, state} . Returns :empty if state is empty.","ref":"custom-implementations.html#workers","title":"Custom Implementations - Workers","type":"extras"},{"doc":"It's quite simple when using the Behaviours mechanism in Elixir. For example, you want to define a new implementation for callers. To do this, you need to create a module that inherits the Poolex.Callers.Behaviour and implement all its functions. defmodule MyApp.MyAmazingCallersImpl do @behaviour Poolex.Callers.Behaviour def init , do : { } def add ( state , caller ) , do : #... end If you have any ideas what implementations can be added to the library or how to improve existing ones, then please create an issue ! Configuring custom implementations After that, you need to add the following to the configuration (for example, runtime.exs ): config :poolex , callers_impl : MyApp.MyAmazingCallersImpl That's it! Your implementation will be used in Poolex . The configuration for workers might look like this: config :poolex , busy_workers_impl : MyApp.PerfectBusyWorkersImpl , idle_workers_impl : MyApp.FancyIdleWorkersImpl","ref":"custom-implementations.html#writing-custom-implementations","title":"Custom Implementations - Writing custom implementations","type":"extras"},{"doc":"This example is based on the Elixir School's poolboy guide . You can find the source of the below example here: poolex_example .","ref":"example-of-use.html","title":"Example of use","type":"extras"},{"doc":"We describe an actor that can easily become a bottleneck in our application, since it has a rather long execution time on a blocking call. defmodule PoolexExample.Worker do use GenServer def start_link do GenServer . start_link ( __MODULE__ , nil ) end def init ( _args ) do { :ok , nil } end def handle_call ( { :square_root , x } , _from , state ) do IO . puts ( &quot;process \#{ inspect ( self ( ) ) } calculating square root of \#{ x } &quot; ) Process . sleep ( 1_000 ) { :reply , :math . sqrt ( x ) , state } end end","ref":"example-of-use.html#defining-the-worker","title":"Example of use - Defining the worker","type":"extras"},{"doc":"defmodule PoolexExample.Application do @moduledoc false use Application def start ( _type , _args ) do Poolex . child_spec ( pool_id : :worker_pool , worker_module : PoolexExample.Worker , workers_count : 5 , max_overflow : 2 ) ] Supervisor . start_link ( children , strategy : :one_for_one ) end end Please note that 7 workers started at once. 5 of them were launched at initialization and 2 workers were started over the limit based on the max_overflow setting. All supported configuration options are presented in Getting Started guide .","ref":"example-of-use.html#configuring-poolex","title":"Example of use - Configuring Poolex","type":"extras"},{"doc":"Poolex.run/3 is the function that you can use to interface with the worker pool. defmodule PoolexExample.Test do @timeout 60_000 def start do 1 .. 20 |&gt; Enum . map ( fn i -&gt; async_call_square_root ( i ) end ) |&gt; Enum . each ( fn task -&gt; await_and_inspect ( task ) end ) end defp async_call_square_root ( i ) do Task . async ( fn -&gt; Poolex . run! ( :worker_pool , fn pid -&gt; # Let&#39;s wrap the genserver call in a try - catch block. This allows us to trap any exceptions # that might be thrown and return the worker back to Poolex in a clean manner. It also allows # the programmer to retrieve the error and potentially fix it. try do GenServer . call ( pid , { :square_root , i } ) catch e , r -&gt; IO . inspect ( &quot;Poolex transaction caught error: \#{ inspect ( e ) } , \#{ inspect ( r ) } &quot; ) :ok end end , timeout : @timeout ) end ) end defp await_and_inspect ( task ) , do : task |&gt; Task . await ( @timeout ) |&gt; IO . inspect ( ) end Run the test function PoolexExample.Test.start() and see the result: process #PID&lt;0.351.0&gt; calculating square root of 3 process #PID&lt;0.350.0&gt; calculating square root of 2 process #PID&lt;0.349.0&gt; calculating square root of 1 process #PID&lt;0.352.0&gt; calculating square root of 4 process #PID&lt;0.353.0&gt; calculating square root of 5 process #PID&lt;0.349.0&gt; calculating square root of 9 process #PID&lt;0.353.0&gt; calculating square root of 7 {:ok, 1.0} process #PID&lt;0.351.0&gt; calculating square root of 8 process #PID&lt;0.352.0&gt; calculating square root of 6 process #PID&lt;0.350.0&gt; calculating square root of 10 {:ok, 1.4142135623730951} {:ok, 1.7320508075688772} ...","ref":"example-of-use.html#using-poolex","title":"Example of use - Using Poolex","type":"extras"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"To start a cache you can use either start/1 or start_link/1 . Poolex . start_link ( pool_id : :my_pool , worker_module : SomeWorker , workers_count : 10 ) In general you should place it into your Supervision tree for fault tolerance. children = [ Poolex . child_spec ( pool_id : :my_pool , worker_module : SomeWorker , workers_count : 10 , max_overflow : 10 ) ] Supervisor . start_link ( children , strategy : :one_for_one ) The second argument should contain a set of options for starting the pool. Poolex configuration options Option Description Example Default value pool_id Identifier by which you will access the pool :my_pool option is required worker_module Name of module that implements our worker MyApp.Worker option is required workers_count How many workers should be running in the pool 5 option is required max_overflow How many workers can be created over the limit 2 0 worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] worker_start_fun Name of the function that starts the worker :run :start_link","ref":"getting-started.html#starting-pool-of-workers","title":"Getting Started - Starting pool of workers","type":"extras"},{"doc":"After the pool is initialized, you can get a free worker and perform any operations on it. This is done through the main interfaces run/3 and run!/3 . The functions work the same and the only difference between them is that run/3 takes care of the runtime error handling. The first argument is the name of the pool mentioned above. The second argument is the function that takes the pid of the worker as the only parameter and performs the necessary actions. The third argument contains run options. Currently there is only one timeout option that tells to Poolex how long we can to wait for a worker on the call side. iex&gt; Poolex . start_link ( pool_id : :agent_pool , worker_module : Agent , worker_args : [ fn -&gt; 5 end ] , workers_count : 1 ) iex&gt; Poolex . run ( :agent_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) { :ok , 5 } iex&gt; Poolex . run! ( :agent_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) 5 If you would like to see examples of using Poolex, then check out Example of Use .","ref":"getting-started.html#working-with-the-pool","title":"Getting Started - Working with the pool","type":"extras"},{"doc":"Poolex is a library for managing pools of workers. Inspired by poolboy .","ref":"readme.html","title":"Poolex","type":"extras"},{"doc":"With poolex you can: Launch multiple pools of workers and then access the free ones from anywhere in the application. Configure the pool to run additional temporary workers if the load increases. Use your own implementations to define workers and callers access logic. Why `poolex` instead of `poolboy`? - `poolex` is written in Elixir. This library is much more convenient to use in Elixir projects. - `poolboy` is a great library, but not actively maintained at the moment :crying_cat_face: ![Last poolboy commit](https://img.shields.io/github/last-commit/devinus/poolboy?style=flat)","ref":"readme.html#features","title":"Poolex - Features","type":"extras"},{"doc":"Requirement Version Erlang/OTP &gt;= 22 Elixir &gt;= 1.7","ref":"readme.html#requirements","title":"Poolex - Requirements","type":"extras"},{"doc":"Installation Getting Started Starting pool of workers Poolex configuration options Working with the pool Example of use Defining the worker Configuring Poolex Using Poolex Custom implementations Callers Workers Writing custom implementations Contributions","ref":"readme.html#table-of-contents","title":"Poolex - Table of Contents","type":"extras"},{"doc":"Add :poolex to your list of dependencies in mix.exs : def deps do [ { :poolex , &quot;~&gt; 0.5.0&quot; } ] end","ref":"readme.html#installation","title":"Poolex - Installation","type":"extras"},{"doc":"In the most typical use of Poolex, you only need to start pool of workers as a child of your application. children = [ Poolex . child_spec ( pool_id : :worker_pool , worker_module : SomeWorker , workers_count : 5 ) ] Supervisor . start_link ( children , strategy : :one_for_one ) Then you can execute any code on the workers with run/3 : iex&gt; Poolex . run ( :worker_pool , &amp; ( is_pid? ( &amp;1 ) ) , timeout : 1_000 ) { :ok , true } A detailed description of the available configuration or examples of use can be found in documentation .","ref":"readme.html#usage","title":"Poolex - Usage","type":"extras"},{"doc":"If you feel something can be improved, or have any questions about certain behaviours or pieces of implementation, please feel free to file an issue. Proposed changes should be taken to issues before any PRs to avoid wasting time on code which might not be merged upstream. If you are ready to make changes to the project, then please read the Contributing guide first.","ref":"readme.html#contributions","title":"Poolex - Contributions","type":"extras"}]